function [Z,Y]= intercept(z0,y0,u0,R,t,b)
if nargin==5
    b=0;
end

m=tan(u0);
n=-tan(u0)*z0+y0;

a=R+t;
A=1+m^2;
B=2*(m*(n-b)-a);
C=a^2+(n-b)^2-R^2;
Z1=(-B-sqrt(B^2-4*A*C))/(2*A);
Z2=(-B+sqrt(B^2-4*A*C))/(2*A);
Y1=m*Z1+n;
Y2=m*Z2+n;

D1=sqrt((Z1-t)^2+Y1^2);
D2=sqrt((Z2-t)^2+Y2^2);
if D1<D2
Z=Z1;
Y=Y1;
else
    Z=Z2;
    Y=Y2;
end %end of if
if abs(R)>1e10
     Z = t;
     Y=m*Z+n;
end
end %end of function

