
function  plotting(D,R,t,n,z,Z,y,Y,ASi,handles)

 N= length(t);
 zmax = sum(t);
 Dimg =Y(end);
 Dobj =Y(1);% y(1) is object height
 drawGeometry(zmax,Dobj,Dimg);
  
  for j=1:N
        
     if  j==ASi 
        drawAperture(z(j),D(j));
     else
        drawLens(D,R,t,n,ASi);      
     end
  end
 light = get(handles.btn_lightselection,'value');
      if light==1 
         paraxialray(z,y,D);
         exactray(Z,Y,D); 
      elseif light==2
         exactray(Z,Y,D);
      elseif light==3
         paraxialray(z,y,D);
      end
  end   
  



function paraxialray(z,y,D)
N=length(z)-1;

   for k=1:N
      if abs(y(k))>abs(D(k)/2)
         break;
      else
         plot([z(k) z(k+1)], [y(k) y(k+1)],'color','r');%paraxial
      end
   end
end

function exactray(Z,Y,D)
N=length(Z)-1;
  for k=1:N
     if  abs(Y(k))>abs(D(k)/2)
        break;
     else
        line([Z(k) Z(k+1)], [Y(k) Y(k+1)],'color','b');%exact
    end
  end
end


function drawLens(D,R,t,n,ASi)
 N= length(t);
  
 for j=2:length(D)-1
      if R(j)==inf
         R(j)=1.e3;
         R(ASi)=inf;
      end
       [a b] = arc( R(j),sum(t(1:j-1)),D(j) );
       v(j-1,:)=a;
       d(j-1,:)=b;
 end
  
  w= length(v);
    for j=1:w
       if  n(j+1)>1
          line([v(j) v(j+1)],[d(j,1)   d(j,1)],'Color','k','LineWidth',1);
          line([v(j) v(j+1)],[-d(j,1) -d(j,1)],'Color','k','LineWidth',1);
       end
   end
end %function drawLens end
    
    

 function drawAperture(z,D)
   line([z z], [-D/2 -D], 'LineWidth',1, 'color','k');
   line([z z], [+D/2  D], 'LineWidth',1, 'color','k');
 end



function drawGeometry(zmax,Dobj,Dimg)
 % optical axis
 line([0 zmax],[0 0], 'Color','k');
% OBJ plane
 line([0 0],[-Dobj Dobj],'Color','k');
 % IMA plane
 line([zmax zmax],[-Dimg Dimg],'Color','k'); 
 % determine axis size
xlim([-zmax/10 zmax*1.1])
axis equal
end
